function [Events Parameters Stimuli_sets Block_Export Trial_Export  Numtrials]=Demo(Parameters, Stimuli_sets, Trial, Blocknum, Modeflag, Events,Block_Export,Trial_Export,Demodata)
loadblockspace


if strcmp(Modeflag,'InitializeBlock');
    
                                    %Stimstructs
    
    %This code creates text that serve as the target and mask
    stimstruct = CreateStimStruct('text'); %Type of stimulus
    stimstruct.stimuli = {'+';'#####'; '@@@@@'}; %contains 3 Stimuli (The fixaion cross, the target, and the mask)
    stimstruct.color = [0,0,0]; %defines color  in Red, Green and Blue.  Values 0 to 255 (max intensity)
    stimstruct.size = 44; %defines the size of the font presented
    Stimuli_sets(1) = Preparestimuli(Parameters,stimstruct); %This stimulus set is defined as #1
    
    %This is a stimuls set containing the target words
    stimstruct = CreateStimStruct('text'); 
    stimstruct.stimuli = {'hello';'apple';'water';'throw';'phone'}; 
    stimstruct.color = [0,0,0]; 
    stimstruct.size = 44;
    Stimuli_sets(2) = Preparestimuli(Parameters,stimstruct); %This stimulus set is defined as #2
   
    %This is a stimulus set containing an intro text and a farewell message
    stimstruct = CreateStimStruct('text'); 
    stimstruct.stimuli = {'You are about to participate in a masking experiment';'Thank you for participating!'}; 
    stimstruct.color = [0,0,0]; 
    stimstruct.size = 44;
    Stimuli_sets(3) = Preparestimuli(Parameters,stimstruct); %This stimulus set is defined as #2

    
    %Sets the number of trials
    Numtrials = 5;
    
    
elseif strcmp(Modeflag,'InitializeTrial');
    
    %For simplicity, define these shorter names so that (locx, locy) is the center of the screen
    locx = Parameters.centerx;
    locy = Parameters.centery;
    
    
                                    %Timing Variables
    
    %Relative to the start of a trial, when does the instruction prompt appear?
    prompt_time = .1;
    
    %This sets the onset time of the fixation as 3 seconds after the initial prompt 
    fix_onsettime = prompt_time + 1.5;
    
    %This line defines the onset time of the word relative to the fixation. .5 seconds = 500 milliseconds
    stim_onsettime = fix_onsettime  + .5; 
    
    %The mask appears 1 second after the stimulus 
    mask_onsettime = stim_onsettime + .1;
    
    %This defines a time at which the screen will go blank after the mask
    blanktime = mask_onsettime + .1;
    
    %Displays a farewell prompt
    farewell_time = blanktime +1.5;
    
    %Time at which the trial ends relative to mask offset
    trial_endtime =  farewell_time + 1.5;
    
    
  
                                        %Events
    
    %Displays instructions prompt on the first trial
    if Trial == 1  
        Events = newevent_show_stimulus(Events,3,1,locx,locy,prompt_time ,'screenshot_no','clear_yes');
    end
    
    
    %Stimuli
    
    %The fixation cross appears before the target
    Events = newevent_show_stimulus(Events,1,1,locx,locy,fix_onsettime ,'screenshot_no','clear_yes');
    
    %The target stimulus: Stimset 1, Stimnumber 2
    Events = newevent_show_stimulus(Events,2,randi(5),locx,locy,stim_onsettime,'screenshot_no','clear_yes');
    
    %The mask stimulus: Stimset 1, Stimnumber 3
    Events = newevent_show_stimulus(Events,1,2,locx,locy,mask_onsettime,'screenshot_no','clear_yes');
    
    %The mask stimulus: Stimset 1, Stimnumber 3
    Events = newevent_show_stimulus(Events,1,3,locx,locy,mask_onsettime,'screenshot_no','clear_no');

    
    %Blanks the screen
    Events = newevent_blank(Events,blanktime);
    
    
    %Displays a farewell prompt
    if Trial == 5
        Events = newevent_show_stimulus(Events,3,2,locx,locy,farewell_time,'screenshot_no','clear_yes');
    end
    
    
    %Creates an event to end the trial
    Events = newevent_end_trial(Events,trial_endtime);
    
    
elseif strcmp(Modeflag,'EndTrial');
    
    
    
elseif strcmp(Modeflag,'EndBlock');
    
   
else
    
    %Something went wrong in Runblock (You should never see this error)
       error('Invalid modeflag');
       
end
saveblockspace
end