function [Events Parameters Stimuli_sets Block_Export Trial_Export  Numtrials]=Demo(Parameters, Stimuli_sets, Trial, Blocknum, Modeflag, Events,Block_Export,Trial_Export,Demodata)
loadblockspace

if strcmp(Modeflag,'InitializeBlock');
    
    
    %Fixation Cross
    stimstruct = CreateStimStruct('text');
    stimstruct.stimuli = {'+';'You are about to take part in a cueing experiment.';'Your target is the slanted gabor.';
        'Press "1" if the slanted gabor is on the left and "0" if on the right.';'Respond as quickly as possible.'};
    Stimuli_sets(1) = Preparestimuli(Parameters,stimstruct);
    
    %Cue
    stimstruct = CreateStimStruct('shape');
    stimstruct.stimuli = {'DrawLine'}; %Size
    stimstruct.linelength = 75; %Number of stripes
    stimstruct.linewidth = 10; %Angle
    Stimuli_sets(2) = Preparestimuli(Parameters,stimstruct);
    
    %Target Gabor Stimstruct:
    stimstruct = CreateStimStruct('gabor');
    stimstruct.stimuli = {200};
    stimstruct.orient_deg = 10;
    stimstruct.norm_freq = 1;
    stimstruct.contrast = .5;
    stimstruct.bg_contrast = 0;
    Stimuli_sets(3) = Preparestimuli(Parameters,stimstruct);
    
    %Distractor Gabor Stimstruct
    stimstruct = CreateStimStruct('gabor');
    stimstruct.stimuli = {200};
    stimstruct.orient_deg = 10;
    stimstruct.norm_freq = 10;
    stimstruct.contrast = .5;
    stimstruct.bg_contrast = 0;
    Stimuli_sets(4) = Preparestimuli(Parameters,stimstruct);
    
    
    %Sets the number of trials:
    Numtrials = 10;
    
    
    %Trial Order Information
    trialtype = [1 1 1 1 1 2 2 2 2 2];
     trialtype = shuffle(trialtype);
     validraw = 0;
     invalidraw = 0;
    
    
    
elseif strcmp(Modeflag,'InitializeTrial');
    
    %For simplicity, this defines the center into shorter names (i.e. locx and locy)
    locx = Parameters.centerx;
    locy = Parameters.centery;
    
    %Presents instructions
    if Trial == 1
        instruction_time = .1;
        Events = newevent_show_stimulus(Events,1,2,locx,locy-200,instruction_time,'screenshot_no','clear_yes');
        Events = newevent_show_stimulus(Events,1,3,locx,locy-100,instruction_time,'screenshot_no','clear_no');
        Events = newevent_show_stimulus(Events,1,4,locx,locy+100,instruction_time,'screenshot_no','clear_no');
        Events = newevent_show_stimulus(Events,1,5,locx,locy+200,instruction_time,'screenshot_no','clear_no');
        fix_time = instruction_time + 10;
    else
        fix_time = .1;
    end
    
    %Timing Variables
    cue_time = 1.5 + fix_time;
    stim_time = cue_time +.1;
    blank_time = stim_time + .1;
    response_time = blank_time + .1;
    blank2_time = response_time + .1;
    trial_endtime = response_time + .1;
    locx = Parameters.centerx;
    locy = Parameters.centery;
    side = ceil(rand*(2));
    
    %Determines the target and distractor locations
    if side == 1
        targetx = locx - 500;
        distractorx = locx + 500;
        
    elseif side == 2
        targetx = locx + 500;
        distractorx = locx - 500;
    end
    
    
    %Determines the trial type
    if  trialtype(Trial) == 1 %Valid
        cuex = targetx;
    elseif  trialtype(Trial) == 2 %Invalid
        cuex = distractorx;
    end
    
    
    
    responsestruct = CreateResponseStruct; %Creates the responsestruct
    responsestruct.allowedchars = '10';  %Properties of the responsestruct
    
    
                                               %Events
    
    %Fixation
    Events = newevent_show_stimulus(Events,1,1,locx,locy,fix_time,'screenshot_no','clear_yes');
    
    %Cue
    Events = newevent_show_stimulus(Events,2,1,cuex,locy-200,cue_time,'screenshot_no','clear_no');
    Events = newevent_show_stimulus(Events,2,1,cuex,locy+200,cue_time,'screenshot_no','clear_no');
    %Target
    Events = newevent_show_stimulus(Events,3,1,targetx,locy,stim_time,'screenshot_no','clear_yes');
    
    %Distractor
    Events = newevent_show_stimulus(Events,4,1,distractorx,locy,stim_time,'screenshot_no','clear_no');
    
    %Blanks the screen
    Events = newevent_blank(Events,blank_time);
    
    %Response
    [Events, evnum] = newevent_keyboard(Events,response_time,responsestruct); %the event itself
    
    %Blanks the screen after response
    Events = newevent_blank(Events,blank2_time);
    
    %Ends the trial
    Events = newevent_end_trial(Events,trial_endtime);
    
elseif strcmp(Modeflag,'EndTrial' );
    
    
                                                %Response data
    
    Trial_Export.rt = Events.responsert{evnum};
    
    Trial_Export.response = Events.response{evnum} - 48;
    
    Trial_Export.trialtype =  trialtype(Trial);
    
    if  trialtype(Trial) == 1
         validraw =  validraw + Events.responsert{evnum};
    elseif  trialtype(Trial) == 2
         invalidraw =  invalidraw + Events.responsert{evnum};
    end
    
    if Trial == 10
        ValidRT =  validraw/5
        InvalidRT =  invalidraw/5
    end
    
    
elseif strcmp(Modeflag,'EndBlock');
    
    %You may wish to do some final analysis here before the experiment is over
    
    
else
    
    %Something went wrong in Runblock (You should never see this error)
       error('Invalid modeflag');
       
end
saveblockspace
end