function [Events Parameters Stimuli_sets Block_Export Trial_Export  Numtrials]=Demo(Parameters, Stimuli_sets, Trial, Blocknum, Modeflag, Events,Block_Export,Trial_Export,Demodata)
loadblockspace

if strcmp(Modeflag,'InitializeBlock');
    
    
    %Intro text
    stimstruct = CreateStimStruct('text');
    stimstruct.stimuli = {'You are about to see an optical illusion!'};
    Stimuli_sets(1) = Preparestimuli(Parameters,stimstruct);
    
    %Background shapes
    stimstruct = CreateStimStruct('image');
    stimstruct.stimuli = {'stepping_feet_background.jpg'; 'stepping_feet_background_flipped.jpg'};
    Stimuli_sets(2) = Preparestimuli(Parameters,stimstruct);
    
    %Moving shapes
    stimstruct = CreateStimStruct('shape');
    stimstruct.stimuli = {'FillRect','FillRect'};
    stimstruct.xdim = [120,120];
    stimstruct.ydim = [50,50];
    stimstruct.color = [255,255,0; 0,0,150];
    Stimuli_sets(3) = Preparestimuli(Parameters,stimstruct);
    
    
    %Sets the number of trials
    Numtrials = 1;
    
    
    
elseif strcmp(Modeflag,'InitializeTrial');
    
    
    %Event Parameters
    %For simplicity, this defines the center into shorter names (i.e. locx and locy)
    locx = Parameters.centerx;
    locy = Parameters.centery;
    
    %Present the instructions
    if Trial == 1
        instruction_time = .1;
        Events = newevent_show_stimulus(Events,1,1,locx,locy,instruction_time,'screenshot_no','clear_yes');
        background_time = instruction_time +3;
    else
        background_time = .1;
    end
    
    feet_time = background_time;
    end_time = background_time + 20;
    
    
    %Displays "feet" moving on background
    for i = 1:100;
        Events = newevent_show_stimulus(Events,2,1,locx,locy,background_time + (.033*i),'screenshot_no','clear_yes');
        Events = newevent_show_stimulus(Events,3,1,locx - 400 + (8*i),locy + 75,feet_time + (.033*i),'screenshot_no','clear_no');
        Events = newevent_show_stimulus(Events,3,2,locx - 400 + (8*i),locy - 75,feet_time + (.033*i),'screenshot_no','clear_no');
    end
    
    for i = 101:200;
        j = i-100;
        Events = newevent_show_stimulus(Events,2,1,locx,locy,background_time + (.033*i),'screenshot_no','clear_yes');
        Events = newevent_show_stimulus(Events,3,1,locx + 400 - (8*j),locy + 75,feet_time + (.033*i),'screenshot_no','clear_no');
        Events = newevent_show_stimulus(Events,3,2,locx + 400 - (8*j),locy - 75,feet_time + (.033*i),'screenshot_no','clear_no');
    end
    
    for i = 201:300;
        k = i-200;
        Events = newevent_show_stimulus(Events,2,1,locx,locy,background_time + (.033*i),'screenshot_no','clear_yes');
        Events = newevent_show_stimulus(Events,3,1,locx - 400 + (8*k),locy + 75,feet_time + (.033*i),'screenshot_no','clear_no');
        Events = newevent_show_stimulus(Events,3,2,locx - 400 + (8*k),locy - 75,feet_time + (.033*i),'screenshot_no','clear_no');
    end
    
    for i = 301:400;
        l = i-300;
        Events = newevent_show_stimulus(Events,2,1,locx,locy,background_time + (.033*i),'screenshot_no','clear_yes');
        Events = newevent_show_stimulus(Events,3,1,locx + 400 - (8*l),locy + 75,feet_time + (.033*i),'screenshot_no','clear_no');
        Events = newevent_show_stimulus(Events,3,2,locx + 400 - (8*l),locy - 75,feet_time + (.033*i),'screenshot_no','clear_no');
    end
    
    
    for i = 401:500;
        m = i-400;
        Events = newevent_show_stimulus(Events,2,1,locx,locy,background_time + (.033*i),'screenshot_no','clear_yes');
        Events = newevent_show_stimulus(Events,3,1,locx - 400 + (8*m),locy + 75,feet_time + (.033*i),'screenshot_no','clear_no');
        Events = newevent_show_stimulus(Events,3,2,locx - 400 + (8*m),locy - 75,feet_time + (.033*i),'screenshot_no','clear_no');
    end
    
    for i = 501:600;
        n = i-500;
        Events = newevent_show_stimulus(Events,2,1,locx,locy,background_time + (.033*i),'screenshot_no','clear_yes');
        Events = newevent_show_stimulus(Events,3,1,locx + 400 - (8*n),locy + 75,feet_time + (.033*i),'screenshot_no','clear_no');
        Events = newevent_show_stimulus(Events,3,2,locx + 400 - (8*n),locy - 75,feet_time + (.033*i),'screenshot_no','clear_no');
    end
    
    %Ends trial
    Events = newevent_end_trial(Events,end_time);
    
    
elseif strcmp(Modeflag,'EndTrial');
    
    
    
    
elseif strcmp(Modeflag,'EndBlock');
    
    
    %You may wish to do some final analysis here before the experiment is over
    
    
else
    
    %Something went wrong in Runblock (You should never see this error)
    error('Invalid modeflag');
    
end
saveblockspace
end