function [Events Parameters Stimuli_sets Block_Export Trial_Export  Numtrials]=Demo(Parameters, Stimuli_sets, Trial, Blocknum, Modeflag, Events,Block_Export,Trial_Export,Demodata)
loadblockspace

if strcmp(Modeflag,'InitializeBlock');
    
    %Stimstructs
    
    %This code creates the black rectangle that serves as the background
    stimstruct = CreateStimStruct('shape'); %Type of stimulus
    stimstruct.stimuli = {'FillRect'}; %Contains 1 stimulus (rectangle)
    stimstruct.color = [0,0,0]; %Defines color in red, green, and blue in values of 0 to 255 (min to max intensity)
    stimstruct.xdim = 500;  %Defines the x-dimension of the rectangle
    stimstruct.ydim = 500; %y-dimension
    Stimuli_sets(1) = Preparestimuli(Parameters,stimstruct); %This stimulus set is defined as #1
    
    %Horizontal white rectangle
    stimstruct = CreateStimStruct('shape');
    stimstruct.stimuli = {'FillRect'};
    stimstruct.color = [255,255,255];
    stimstruct.xdim = 80;
    stimstruct.ydim = 10;
    Stimuli_sets(2) = Preparestimuli(Parameters,stimstruct);
    
    %Vertical white rectangle
    stimstruct = CreateStimStruct('shape');
    stimstruct.stimuli = {'FillRect'};
    stimstruct.color = [255,255,255];
    stimstruct.xdim = 5;
    stimstruct.ydim = 100;
    Stimuli_sets(3) = Preparestimuli(Parameters,stimstruct);
    
    %The intro and farewell message
    stimstruct = CreateStimStruct('text');
    stimstruct.stimuli = {'Prepare to be amazed by an optical illusion!!!';'This concludes the optical illusion.'};
    Stimuli_sets(4) = Preparestimuli(Parameters,stimstruct);
    
    
    %Sets the number of trials
    Numtrials = 1;
    
    
    
elseif strcmp(Modeflag,'InitializeTrial');
    BlockError
    %For simplicity, this defines these shorter names so that (locx, locy) is the center of the screen
    locx = Parameters.centerx;
    locy = Parameters.centery;
    
    
    %Timing Variables
    
    %Time at which the prompt appears in relation to the start of the trial
    prompt_time = .1;
    
    %Time at which the illusion stimuli appear
    stim_onsettime = prompt_time +2;
    
    %Time at which the farewell message appears
    farewell_time = stim_onsettime + 10;
    
    %Time at which the farewell message disappears
    trial_blanktime = farewell_time + 3;
    
    %Time at which the trial ends
    trial_endtime =  trial_blanktime+ .1;
    
    
    %Events
    
    %Prompt
    Events = newevent_show_stimulus(Events,4,1,locx,locy,prompt_time,'screenshot_no','clear_yes');
    
    
    %Stimuli
    
    %Black Rectangle: Stimset 1, Stimnumber 1
    Events = newevent_show_stimulus(Events,1,1,locx,locy,stim_onsettime,'screenshot_no','clear_yes');
    
    %Horizontal Line: Stimset 2, Stimnumber 1
    Events = newevent_show_stimulus(Events,2,1,locx,locy,stim_onsettime,'screenshot_no','clear_no');
    
    %Vertical Line : Stimset 3, Stimnumber 1
    Events = newevent_show_stimulus(Events,3,1,locx,locy,stim_onsettime,'screenshot_no','clear_no');
    
    
    %Displays farewell prompt
    Events = newevent_show_stimulus(Events,4,2,locx,locy,farewell_time,'screenshot_no','clear_yes');
    
    %Blanks the screen
    Events = newevent_blank(Events,trial_blanktime);
    
    %Creates an event to end the trial
    Events = newevent_end_trial(Events,trial_endtime);
    
    
    
elseif strcmp(Modeflag,'EndTrial' );
    
    
    
elseif strcmp(Modeflag,'EndBlock');
    
    
else
    
    %Something went wrong in Runblock (You should never see this error)
        BlockError;
    error(err);
 
end
saveblockspace
end