function [Events Parameters Stimuli_sets Block_Export Trial_Export  Numtrials]=Demo(Parameters, Stimuli_sets, Trial, Blocknum, Modeflag, Events,Block_Export,Trial_Export,Demodata)
loadblockspace
if strcmp(Modeflag,'InitializeBlock');
    
    %congruent stimuli
    stimstruct = CreateStimStruct('text');
    stimstruct.stimuli = {'RED','GREEN','BLUE','YELLOW','PURPLE'};
    stimstruct.color = [255,0,0; 0,255,0; 0,0,255; 255,255,0; 255,0,255];
    Stimuli_sets(1) = Preparestimuli(Parameters,stimstruct);
    
    %Incongruent stimuli
    stimstruct = CreateStimStruct('text');
    stimstruct.stimuli = {'RED';'RED';'RED';'RED';'GREEN';'GREEN';'GREEN';'GREEN';'BLUE';'BLUE';'BLUE';'BLUE';'YELLOW';'YELLOW';'YELLOW';'YELLOW';'PURPLE';'PURPLE';'PURPLE';'PURPLE'};
    stimstruct.color = [0,255,0; 0,0,255; 255,255,0; 255,0,255;  %RED
                        255,0,0; 255,255,0; 0,0,255; 255,0,255;  %GREEN
                        0,255,0; 255,0,0; 255,255,0; 255,0,255;  %BLUE
                        0,255,0; 255,0,0; 0,0,255; 255,0,255;    %YELLOW
                        255,0,0; 0,255,0; 0,0,255; 255,255,0];   %PURPLE 
    Stimuli_sets(2) = Preparestimuli(Parameters,stimstruct);
    
    %neutral stimuli
    stimstruct = CreateStimStruct('text');
    stimstruct.stimuli = {'NIGHT','NIGHT','NIGHT','NIGHT','NIGHT','HORSE','HORSE','HORSE','HORSE','HORSE','CAT','CAT','CAT','CAT','CAT','TIME','TIME','TIME','TIME','TIME'};
    stimstruct.color = [0,0,255; 255,0,0; 0,255,0; 255,255,0; 255,0,255;   %NIGHT
                        0,0,255; 255,0,0; 0,255,0; 255,255,0; 255,0,255;  %HORSE
                        0,0,255; 255,0,0; 0,255,0; 255,255,0; 255,0,255;  %CAT
                        0,0,255; 255,0,0; 0,255,0; 255,255,0; 255,0,255;]; %TIME
    Stimuli_sets(3) = Preparestimuli(Parameters,stimstruct);
    
    
    %instructions
    stimstruct = CreateStimStruct('text');
    stimstruct.stimuli = {'Press R G B Y or P to indicate color of the ink (not the word)'};
    stimstruct.stimsize = 20;
    Stimuli_sets(4) = Preparestimuli(Parameters,stimstruct);
    
    %Key codes for the responsestruct
    anskey_R = KbName('R');
    anskey_G = KbName('G');
    anskey_B = KbName('B');
    anskey_Y = KbName('Y');
    anskey_P = KbName('P');
    
    
    trial_type = [1 1 1 1 2 2 2 2 3 3 3 3];
    trial_type = shuffle(trial_type);
    Block_Export.trialtype = trial_type;
    % Set the number of trials
    Numtrials = length(trial_type);
    
        
elseif strcmp(Modeflag,'InitializeTrial');
    
    
    %for simplicity, define these shorter variables
    locx = Parameters.centerx;
    locy = Parameters.centery;
    
    if Trial == 1
        prompt_time = .1;
        word_onsettime = prompt_time +4;
    else
    word_onsettime = .5; 
    end
   
    
    %This time will be used to specify the blank time of a trial
    trial_blanktime = word_onsettime +.01;  
    
    %End of the trial
    trial_endtime = trial_blanktime +1;
    
    
    
    %Depending on which simset is chosen at random, this statement chooses
    %a random word in that stim set
    if trial_type(Trial) == 1
        whichword = ceil(rand*5);
        
    elseif trial_type(Trial) == 2
        whichword = ceil(rand*20);
        
    elseif trial_type(Trial) == 3
        whichword = ceil(rand*20);
    
        
    end
    
    
    
    %show_stimulus syntax:
    %newevent_show_stimulus(Events,stimset,stimnumber,x-location,y-location,onset-time,'screenshot_no','clear_no');
    %Present task instructions
   
    if Trial ==1
    Events = newevent_show_stimulus(Events,4,1,locx,locy,prompt_time,'screenshot_no','clear_yes');
    end
    
    Events = newevent_show_stimulus(Events,trial_type(Trial),whichword,locx,locy,word_onsettime,'screenshot_no','clear_yes');
    
    
    % Create an event to collect a keyboard response
    responsestruct = CreateResponseStruct; %create the responsestruct
    responsestruct.allowedchars = [anskey_R anskey_G anskey_B anskey_Y anskey_P];  %properties of the response struct
   [Events, evnum] = newevent_keyboard(Events,word_onsettime,responsestruct); %the event itself
    
    
    
    
    %create an event to end the trial.
    Events = newevent_blank(Events,trial_blanktime);
    
    Events = newevent_end_trial(Events,trial_endtime);
    
   
    %Export variables 
    Trial_Export.whichword = whichword;
    

    
    
    
    
elseif strcmp(Modeflag,'EndTrial' );
    
    %Export the response data points that you wish to be added into the data file
 
    Trial_Export.rt = Events.responsert{evnum};
    Trial_Export.response = Events.response{evnum};
    
    
    
    
    
    
elseif strcmp(Modeflag,'EndBlock');
    
    
else   %somethign went wrong in runblock (you should never see this error)
        BlockError;
    error(err);
 
end
saveblockspace
end