function [Events Parameters Stimuli_sets Block_Export Trial_Export  Numtrials]=Demo(Parameters, Stimuli_sets, Trial, Blocknum, Modeflag, Events,Block_Export,Trial_Export,Demodata)
loadblockspace

if strcmp(Modeflag,'InitializeBlock');
       
    %Task instructions
    stimstruct = CreateStimStruct('text');
    stimstruct.stimuli = {'Please focus on the fixation cross','+'};
    Stimuli_sets(1) = Preparestimuli(Parameters,stimstruct);
    
    %Creates a stimulus set to present the images
    stimstruct = CreateStimStruct('image');
    stimstruct.stimuli = {'TutorialS1_Blurry.png';'TutorialS1_Sharp.png';'TutorialS1_Normal.png'};
    stimstruct.stimsize = .2;
    Stimuli_sets(2) = Preparestimuli(Parameters,stimstruct);
    

    %Sets the number of trials
    Numtrials = 1;
    
        
elseif strcmp(Modeflag,'InitializeTrial');
    
    
    %For simplicity, this defines the center into shorter names (i.e. locx and locy)
    locx = Parameters.centerx;
    locy = Parameters.centery;
    
    %start off by storing keyboard state so that we don't accidentally code
    %a pre-existing keyboard press as a new one
    [keyIsDown,secs,keyCode]=KbCheck(-1);
    Parameters.dynvars.dynvarkeydownx = keyIsDown;
    Parameters.dynvars.dynvarkeydowny = keyIsDown;
    Parameters.dynvars.stimx = locx-100;
    Parameters.dynvars.stimy = locy;
    
    %variable #1 corresponds to X position of mouse by calling function MouseX.m 
    Events.variableNames{1} = 'Xpos';
    Events.variableFunctions{1} = 'KeyboardX(Parameters)';
    Events.variableUpdateTime(1) = .01;  %updates quickly (20ms)
    

    %variable #2 corresponds to X position of mouse by calling function MouseY.m
    Events.variableNames{2} = 'Ypos';
    Events.variableFunctions{2} = 'KeyboardY(Parameters)';
    Events.variableUpdateTime(2) = .01; %updates quickly (300ms)
    
    stim_onsettime1 = .1; %When the first set of stimuli appears
  
    trial_endtime =  stim_onsettime1 + 10;
    
    %Show the images
    Events = newevent_show_stimulus(Events,1,2,locx,locy,stim_onsettime1,'screenshot_no','clear_yes');
        Events = newevent_show_stimulus(Events,2,1,'Xpos',locy,stim_onsettime1,'screenshot_no','clear_no');
        Events = newevent_show_stimulus(Events,2,2,locx-300,'Ypos',stim_onsettime1,'screenshot_no','clear_no');
    
    
    
    %Creates an Event to end the trial.
    Events = newevent_end_trial(Events,trial_endtime);
    
       
    
elseif strcmp(Modeflag,'EndTrial' );
    
elseif strcmp(Modeflag,'EndBlock');
    
  
else
    
    %Something went wrong in Runblock (You should never see this error)
        BlockError;
    error(err);
        
end
saveblockspace
end