function Demodata = Fulldemographics(Parameters)


if(Parameters.disableinput == 0)   %Skips the demographics dialog if we're in disableinput mode
    %EDITHERE_prompt
    
    %Initial welcome message box text
    prompttxt = sprintf(['Thanks for participating in this experiment.\n\n'...
        'The following screen will ask you questions about your age, sex, handedness, vision, and how much time you spend on a computer.'...
        'You will also be asked questions about language fluency.' ...
        'Please use the TAB button to switch between input fields.\nYour data will remain confidential.'...
        '\n\nClick the OK button to continue.']);
    msg = msgbox(prompttxt,'Welcome!');
    uiwait(msg);
    
    s_num = '1';
    s_num2 = '2';
    
    %EDITHERE_demographics
    
    %#1 Edit the Demo questions here
    prompts = {'Subject Number','Age','Sex (M/F)','How many hours do you use the computer each day?','How many times in a week do you read for fun?','Please re-enter the subject number'};
    
    %#2 Edit the default answers here  (or leave them as '' for blank)
    default_s_info = {'','', '', '', '', '', ''};
    
    validinput = 0;
    
    while  validinput == 0   %Confirm that the subject number is entered correctly by having it re-entered at the top and bottom of this form
        
        %This line puts up the Question box
        s_info = inputdlg(prompts, 'Tell us some things about yourself', 1, default_s_info,struct('WindowStyle','normal'));
        
        %#3  Assign names to each of the variables
        try
            [s_num, s_age, s_sex, s_computer,s_read,s_num2] = deal(s_info{:});
        catch
            error('Demographics data not entered')
        end
        

        
        
        %#4 If any of these answers should be converted into a numeric
        %value, do that here with eval
        %If any of these fail to work, catch the error and try again
        
        if(length(s_num2)==0)
            s_num2 = 'BLANK';
        end
        
        %EDITHERE Add subject restrictions here
        if strcmp(s_num, s_num2) == 1
            if eval(s_age) >= 18
                validinput = 1;
            elseif strcmp(s_num, s_num2) == 0 || eval(s_age) <= 18
                default_s_info = s_info;
                validinput = 0;
            end
        end
        
        
        
        
        
    end
    
    %#5  Put the answers into the demodata stucture, which is stored in UserData
    
    Demodata.s_num = s_num;
    Demodata.s_age = s_age;
    Demodata.s_sex = s_sex;
    Demodata.s_computer = s_computer;
    Demodata.s_read = s_read;
    Demodata.filename = Parameters.datafilename;
    
else
    Demodata.s_num = '999';
    Demodata.filename = Parameters.datafilename;
end





